container_impl_base

Experimental - A base container implementation. More...

`#include <container_impl_base.hpp>`

Inherits standard_container.

## Public Member Functions

void | client_connection_options (const connection_options &opts)
| Connection options that will be to outgoing connections. More...
connection_options | client_connection_options () const
| Connection options that will be to outgoing connections. More...
void | server_connection_options (const connection_options &opts)
| Connection options that will be applied to incoming connections. More...
connection_options | server_connection_options () const
| Connection options that will be applied to incoming connections. More...
void | sender_options (const class sender_options &opts)
| Sender options applied to senders created by this container. More...
class sender_options | sender_options () const
| Sender options applied to senders created by this container. More...
void | receiver_options (const class receiver_options &opts)
| Receiver options applied to receivers created by this container. More...
class receiver_options | receiver_options () const
| Receiver options applied to receivers created by this container. More...
returned< sender > | open_sender (const std::string &url, const class sender_options &opts, const connection_options &copts)
| Open a connection and sender for `url`. More...
returned< receiver > | open_receiver (const std::string &url, const class receiver_options &opts, const connection_options &copts)
| Open a connection and receiver for `url`. More...

## Detailed Description

Experimental - A base container implementation.

This is a thread-safe partial implementation of the proton::container interface to reduce boilerplate code in container implementations. Requires C++11.

You can ignore this class if you want to implement the functions in a different way.

Examples:
  mt/epoll_container.cpp.

## Member Function Documentation

## client_connection_options() [1/2]

void client_connection_options | ( | const connection_options & | opts | ) |

inline

Connection options that will be to outgoing connections.

These are applied first and overriden by options provided in connect() and messaging_handler::on_connection_open().

## client_connection_options() [2/2]

connection_options client_connection_options | ( |  | ) | const

inline

Connection options that will be to outgoing connections.

These are applied first and overriden by options provided in connect() and messaging_handler::on_connection_open().

## open_receiver()

returned<receiver> open_receiver | ( | const std::string & | url,
|  | const class receiver_options & | opts,
|  | const connection_options & | copts
| ) |  |

inline

Open a connection and receiver for `url`.

## open_sender()

returned<sender> open_sender | ( | const std::string & | url,
|  | const class sender_options & | opts,
|  | const connection_options & | copts
| ) |  |

inline

Open a connection and sender for `url`.

## receiver_options() [1/2]

class receiver_options receiver_options | ( |  | ) | const

inline

Receiver options applied to receivers created by this container.

They are applied before messaging_handler::on_receiver_open() and can be overridden.

## receiver_options() [2/2]

void receiver_options | ( | const class receiver_options & | opts | ) |

inline

Receiver options applied to receivers created by this container.

They are applied before messaging_handler::on_receiver_open() and can be overridden.

## sender_options() [1/2]

void sender_options | ( | const class sender_options & | opts | ) |

inline

Sender options applied to senders created by this container.

They are applied before messaging_handler::on_sender_open() and can be overridden.

## sender_options() [2/2]

class sender_options sender_options | ( |  | ) | const

inline

Sender options applied to senders created by this container.

They are applied before messaging_handler::on_sender_open() and can be overridden.

## server_connection_options() [1/2]

void server_connection_options | ( | const connection_options & | opts | ) |

inline

Connection options that will be applied to incoming connections.

These are applied first and overridden by options provided in listen(), listen_handler::on_accept() and messaging_handler::on_connection_open().

## server_connection_options() [2/2]

connection_options server_connection_options | ( |  | ) | const

inline

Connection options that will be applied to incoming connections.

These are applied first and overridden by options provided in listen(), listen_handler::on_accept() and messaging_handler::on_connection_open().

The documentation for this class was generated from the following file:

- proton/io/container_impl_base.hpp